Package picard.illumina

## Class MarkIlluminaAdapters

- java.lang.Object
- - picard.cmdline.CommandLineProgram
  - - picard.illumina.MarkIlluminaAdapters

-     @DocumentedFeature
      public class MarkIlluminaAdapters
      extends CommandLineProgram

  Command line program to mark the location of adapter sequences. This also outputs a Histogram of metrics describing the clipped bases

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `int` | `ADAPTER_TRUNCATION_LENGTH` |
    `List<IlluminaUtil.IlluminaAdapterPair>` | `ADAPTERS` |
    `String` | `FIVE_PRIME_ADAPTER` |
    `File` | `INPUT` |
    `double` | `MAX_ERROR_RATE_PE` |
    `double` | `MAX_ERROR_RATE_SE` |
    `File` | `METRICS` |
    `int` | `MIN_MATCH_BASES_PE` |
    `int` | `MIN_MATCH_BASES_SE` |
    `int` | `NUM_ADAPTERS_TO_KEEP` |
    `File` | `OUTPUT` |
    `Boolean` | `PAIRED_RUN` |
    `int` | `PRUNE_ADAPTER_LIST_AFTER_THIS_MANY_ADAPTERS_SEEN` |
    `String` | `THREE_PRIME_ADAPTER` |

    - ### Fields inherited from class picard.cmdline.CommandLineProgram

      `COMPRESSION_LEVEL, CREATE_INDEX, CREATE_MD5_FILE, GA4GH_CLIENT_SECRETS, MAX_ALLOWABLE_ONE_LINE_SUMMARY_LENGTH, MAX_RECORDS_IN_RAM, QUIET, REFERENCE_SEQUENCE, referenceSequence, specialArgumentsCollection, TMP_DIR, USE_JDK_DEFLATER, USE_JDK_INFLATER, VALIDATION_STRINGENCY, VERBOSITY`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MarkIlluminaAdapters()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected String[]` | `customCommandLineValidation()` | Put any custom command-line validation in an override of this method.
    `protected int` | `doWork()` | Do the work after command line has been parsed.

    - ### Methods inherited from class picard.cmdline.CommandLineProgram

      `checkRInstallation, getCommandLine, getCommandLineParser, getCommandLineParserForArgs, getDefaultHeaders, getFaqLink, getMetricsFile, getPGRecord, getStandardUsagePreamble, getStandardUsagePreamble, getVersion, hasWebDocumentation, instanceMain, instanceMainWithExit, makeReferenceArgumentCollection, parseArgs, requiresReference, setDefaultHeaders, useLegacyParser`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### INPUT

          @Argument(shortName="I")
          public File INPUT

    - #### OUTPUT

          @Argument(doc="If output is not specified, just the metrics are generated",
                    shortName="O",
                    optional=true)
          public File OUTPUT

    - #### METRICS

          @Argument(doc="Histogram showing counts of bases_clipped in how many reads",
                    shortName="M")
          public File METRICS

    - #### MIN_MATCH_BASES_SE

          @Argument(doc="The minimum number of bases to match over when clipping single-end reads.")
          public int MIN_MATCH_BASES_SE

    - #### MIN_MATCH_BASES_PE

          @Argument(doc="The minimum number of bases to match over (per-read) when clipping paired-end reads.")
          public int MIN_MATCH_BASES_PE

    - #### MAX_ERROR_RATE_SE

          @Argument(doc="The maximum mismatch error rate to tolerate when clipping single-end reads.")
          public double MAX_ERROR_RATE_SE

    - #### MAX_ERROR_RATE_PE

          @Argument(doc="The maximum mismatch error rate to tolerate when clipping paired-end reads.")
          public double MAX_ERROR_RATE_PE

    - #### PAIRED_RUN

          @Argument(doc="DEPRECATED. Whether this is a paired-end run. No longer used.",
                    shortName="PE",
                    optional=true)
          public Boolean PAIRED_RUN

    - #### ADAPTERS

          @Argument(doc="Which adapters sequences to attempt to identify and clip.")
          public List<IlluminaUtil.IlluminaAdapterPair> ADAPTERS

    - #### FIVE_PRIME_ADAPTER

          @Argument(doc="For specifying adapters other than standard Illumina",
                    optional=true)
          public String FIVE_PRIME_ADAPTER

    - #### THREE_PRIME_ADAPTER

          @Argument(doc="For specifying adapters other than standard Illumina",
                    optional=true)
          public String THREE_PRIME_ADAPTER

    - #### ADAPTER_TRUNCATION_LENGTH

          @Argument(doc="Adapters are truncated to this length to speed adapter matching.  Set to a large number to effectively disable truncation.")
          public int ADAPTER_TRUNCATION_LENGTH

    - #### PRUNE_ADAPTER_LIST_AFTER_THIS_MANY_ADAPTERS_SEEN

          @Argument(doc="If looking for multiple adapter sequences, then after having seen this many adapters, shorten the list of sequences. Keep the adapters that were found most frequently in the input so far. Set to -1 if the input has a heterogeneous mix of adapters so shortening is undesirable.",
                    shortName="APT")
          public int PRUNE_ADAPTER_LIST_AFTER_THIS_MANY_ADAPTERS_SEEN

    - #### NUM_ADAPTERS_TO_KEEP

          @Argument(doc="If pruning the adapter list, keep only this many adapter sequences when pruning the list (plus any adapters that were tied with the adapters being kept).")
          public int NUM_ADAPTERS_TO_KEEP

  - ### Constructor Detail

    - #### MarkIlluminaAdapters

          public MarkIlluminaAdapters()

  - ### Method Detail

    - #### customCommandLineValidation

          protected String[] customCommandLineValidation()

      Description copied from class: `CommandLineProgram`
      Put any custom command-line validation in an override of this method. clp is initialized at this point and can be used to print usage and access argv. Any options set by command-line parser can be validated.
      Overrides:
        `customCommandLineValidation` in class `CommandLineProgram`
      Returns:
        null if command line is valid. If command line is invalid, returns an array of error message to be written to the appropriate place.

    - #### doWork

          protected int doWork()

      Description copied from class: `CommandLineProgram`
      Do the work after command line has been parsed. RuntimeException may be thrown by this method, and are reported appropriately.
      Specified by:
        `doWork` in class `CommandLineProgram`
      Returns:
        program exit status.